/* NewFile Tracker Add-on */

#include <Be.h>
#include <Application.h>
#include <stdio.h>
#include <TrackerAddOn.h>
#include <Node.h>
#include <String.h>
#include <Directory.h>
#include <FindDirectory.h>
#include <Path.h>
#include <File.h>
#include <malloc.h>
#include <cstring>
#include <Entry.h>

#include "NewFile_window.h"

// the name of the add_on
#define ADDON_NAME "NewFile"
#define ADDON_VERS "001"

void read_attr(int number);			// number of the attr you want to rea
void write_attr(int number);

void create_name(void);
void create_unique_number(void);
void create_file(void);

void error(const char *message);

void install_myself(void);
void rename_myself(void);

void addon_is_at_home(void);
void settings_window(void);
void myAboutWindow(void);

void error_check(const char * message, int32 status);

// Global
BDirectory	dir_where_called;		// directory of creation
BPath		path_where_called;		// path of creation
BEntry		entry_where_called;		// entry of creation

BFile		new_file;				// the new file
BEntry 		entry;					// for checking if new_file_name already exists

BString		path_to_new_file;
BNode		new_file_node;

app_info 	my_app_info;	// getting ref of app
BNode 		my_app_node;	// getting the node of app
attr_info	info;			// checking if attribute X exists

status_t	status;			// success check-point

// Attributes
BString attr_name[9] = {"Be Creative","File Name", "File Type", "Ask About Name", "Add Extension",
								"Extension", "Open File", "Use My App", "My Preferred App"};

BString attr_value[9] = {"1","New Text File", "text/plain", "0", "1",
								".txt", "1", "0", "Application/x-vnd.Be-NPOS"};

// Creating name of new file
BString new_file_name;		// file_name (+ unique_number) (+ extension)	
BString unique_number;		// Added to new_file_name, if a file already exists with new_file_name

extern "C" void 
process_refs(entry_ref dir_ref, BMessage *msg, void *)
{
	// If NewFile is run initially as Add-On, how to handle settings-attributes?

	const char my_app_sig[] = "application/x-vnd.JonasSundstrom.NewFile";

	image_info info;
	int32 cookie = 0;

	while (get_next_image_info(0, &cookie, &info) == B_OK)	// Wouldn't work w/ multiple NewFile loaded
	{														// Does it ever happen?
		if (info.type == B_ADD_ON_IMAGE)					// ...
		{
			char app_sig_temp[512];
			my_app_node.SetTo(info.name);
			my_app_node.ReadAttr("BEOS:APP_SIG", B_STRING_TYPE, 0, app_sig_temp, 512);
			if (strcmp(app_sig_temp, my_app_sig) == 0)
			{
				break;
			}
		}
	}

	printf("\n");

	for(int loop = 0; loop <= 8; loop++)	// read all attributes.
	{
		read_attr(loop);
	}

	status = dir_where_called.SetTo(&dir_ref);
	if (status != B_OK)
	{
		error(ADDON_NAME ": Ehh.. *What* directory?");
		exit(1);
	}

	status = entry_where_called.SetTo(& dir_ref, false);
	if (status != B_OK)
	{
		error(ADDON_NAME ": Ehh.. *What* entry?");
		exit(1);
	}


	status = path_where_called.SetTo(& entry_where_called);
	if (status != B_OK)
	{
		error(ADDON_NAME ": Ehh.. *What* path?");
		exit(1);
	}


	create_name();
	create_file();

	// We might like to open the file... but how?
	// if attr_value[7].String == "1"
	// be_roster->Launch( something )

	printf("\n");
}

int main(int argc, char *argv[], char *arge[]) 
{
	printf("\n");

	new BApplication("application/x-vnd.JonasSundstrom.NewFile");

	// Getting my app_info
	be_app->GetAppInfo(& my_app_info);

	// Setting up a node to read/write my attributes
	status = my_app_node.SetTo (& my_app_info.ref);

	if (status != B_NO_ERROR)
	{ error("Uh, Hullo?..\n It's so dark I can't see where I am.."); exit(1);}

	for(int loop = 0; loop <= 8; loop++)	// read all attributes.
	{
		read_attr(loop);
	}

	addon_is_at_home();	

	settings_window();

//	Settings_window will have to do this:
/*
	for(int loop = 0; loop <= 8; loop++)	// write all attributes.
	{
		write_attr(loop);
	}
*/

	be_app->Run();

	delete be_app;
	return 0;
}

void myAboutWindow()
{
  (new BAlert(0, ADDON_NAME " " ADDON_VERS " Tracker add-on\n\n"
              "Compiled by Jonas Sundström.\n"
			  "Copyleft " B_UTF8_COPYRIGHT " 1999 Mirilla Software.\n\n"
              "Install-Me functionality by Raphael Moll.\n"
			  "Thanks to Be Inc. and the developer community, for tips & sample code.\n\n"
			  "It should be harmless, but you never know..\n\n"
			  "Feedback goes to:\n"
			  "s96j1su@csd.uu.se\n"
              "http://www.csd.uu.se/~s96j1su/",
              "Interesting.."))->Go(); 
}

void read_attr(int number)
{
	ssize_t		read_bytes = 0;
	char	*	my_buffer  = (char *) malloc(B_FILE_NAME_LENGTH);

	status = my_app_node.GetAttrInfo(attr_name[number].String(), &info);

		error_check("read_attr : my_app_node.GetAttrInfo", status);

	if (status == B_ENTRY_NOT_FOUND)
	{
		printf("Couldn't find attribute: ");
		printf(attr_name[number].String());
		printf("\n");
		return;
	}	
	else if (status != B_NO_ERROR)
	{
		error("Darn.. Somethings wrong about my ");
		printf(attr_name[number].String());
		printf(" attribute.\n");
		return;
	}

	read_bytes = my_app_node.ReadAttr(attr_name[number].String(), B_STRING_TYPE, 0, my_buffer, 256);

	if (read_bytes > 0)
	{
		attr_value[number].Truncate(0);			// I had some problems to Assign the char * to the BStrin
		attr_value[number].Append(my_buffer, read_bytes);	// so this is a temporary solution
		printf("Appending buffer\n");						// Oh, the basics can be so annoying sometimes
	}
	// else use standard values
	
		error_check("read_attr() -- .ReadAttr()", read_bytes);

	printf("attribute : ");
	printf(attr_name[number].String());
	printf("\n");

	printf("value: ");
	printf(attr_value[number].String());
	printf("\n");
	printf("read_bytes: %d", read_bytes);
	printf("\n");

	printf("buffer length: %d", strlen(my_buffer));
	printf("\n");

	free(my_buffer); my_buffer = NULL;	
}

void write_attr(int number)
{
	ssize_t		written_bytes = 0;

    written_bytes = my_app_node.WriteAttr(attr_name[number].String(), B_STRING_TYPE, 0,
									attr_value[number].String(), attr_value[number].Length());

	if(written_bytes != attr_value[number].Length())
	{ error("failure: written_bytes != attr_value[number].Length()"); }

	error_check("write_attr() -- .WriteAttr() ", written_bytes);

	printf("attribute: ");
	printf(attr_name[number].String());
	printf("\n");

	printf("value: ");
	printf(attr_value[number].String());
	printf("\n");
	printf("written_bytes: %d", written_bytes);
	printf("\n");
}

void install_myself(void)
/*
	This function is a slightly adapted version of installOurself() from the
	Tracker Add-On ZipMe, written by R'alf <mailto:raphael.moll@capway.com>
	Thanks !

	Copy *this* binary file into /boot/home/config/add-ons/Tracker/,
	making sure the directories exists and can be created.
*/
{
BEntry my_app_entry;	// No need to manipulate my_app_node
BPath	idealPath;
BDirectory addonsDir;
BDirectory trackerDir;

	status = my_app_entry.SetTo( & my_app_info.ref );
	if (status != B_NO_ERROR) goto bail_out_error;

	// The ideal directory is B_USER_ADDONS_DIRECTORY+"./Tracker"
	// create it if doesn't exists

	status = find_directory(B_USER_ADDONS_DIRECTORY, &idealPath, true);
	if (status != B_NO_ERROR && status != B_FILE_EXISTS) goto bail_out_error;

	if (addonsDir.SetTo(idealPath.Path()) != B_NO_ERROR) goto bail_out_error;
	status = addonsDir.CreateDirectory("Tracker", &trackerDir);
	if (status == B_FILE_EXISTS) status = trackerDir.SetTo(&addonsDir, "Tracker");
	if (status != B_NO_ERROR) goto bail_out_error;
	if (trackerDir.InitCheck() != B_NO_ERROR) goto bail_out_error;

	// move executable
	status = my_app_entry.MoveTo(&trackerDir, NULL, true);
	if (status != B_NO_ERROR && status != B_FILE_EXISTS) goto bail_out_error;

	return;

	bail_out_error:
	error(  "Help! Something's wrong. I can't move myself to \n"
			"/boot/home/config/add-ons/Tracker/");
}

void error(const char *message)
/*
	Displays a message in a dialog box (yes, believe it!)
	This function is a copy&paste of installOurself() from
	the Tracker Add-On ZipMe, written by Raphael Moll.
*/
{
	BAlert *alert = new BAlert(ADDON_NAME " Error :\n", message, "OK");
	alert->Go();
}

void rename_myself()
{

}

void addon_is_at_home()
{
	// Is Add-On really at home ??
	BEntry		my_app_entry;
	BPath		my_app_path;
	status_t	status;

	BString		path_without_name;

	status = my_app_entry.SetTo (& my_app_info.ref, true);
	
	error_check("addon_is_at_home():my_app_entry.SetTo()", status);

	status = my_app_path.SetTo(& my_app_entry);

	error_check("addon_is_at_home():my_app_path.SetTo()", status);

	path_without_name = my_app_path.Path();
	path_without_name.Truncate( strlen(my_app_path.Path()) - strlen(my_app_path.Leaf()) );

	printf(path_without_name.String());
	printf("\n");

	if (path_without_name == "/boot/home/config/add-ons/Tracker/")
	{
		printf("Add-On is at home. Let's get going with the files! \n");
		return;
	}

	// else, ask the user if NewFile can move itself.

	BAlert *box = new BAlert(ADDON_NAME,
							 "Hi! I'm " ADDON_NAME " " ADDON_VERS " !\n\n"
							 "I'd like to live in\n"
							 "/boot/home/config/add-ons/Tracker/\n\n"
							 "I could try to move myself, if you like..",
							 "Don't move", "Move", NULL,
							 B_WIDTH_FROM_WIDEST);
	
	if (box->Go() == 1) install_myself();
}

void settings_window()
{
	printf("settings_window()\n");

	BRect	WinSize(100,100,410,300);

	NewFile_window	* my_window = new NewFile_window(WinSize, my_app_node);
	printf("window created.\n");
	my_window->Show();
	printf("window shown.\n");
}

void create_name()
{
	printf("Beginning of create_name(): ");
	printf(attr_value[1].String());
	printf("\n");

	status_t status;
	new_file_name = attr_value[1];
	if (attr_value[4] == "1")
		new_file_name.Append(attr_value[5].String());

	// Is there a file named file_name (w/ unique_number and extension)
	status = dir_where_called.FindEntry(new_file_name.String(), &entry);
	if (status != B_OK)
	{
		return;
	}
	else
	{
		new_file_name	=	attr_value[1];
		new_file_name.Append(" 1");				// a call to create_unique_number() ??;		
		new_file_name.Append(attr_value[5]);
		return;
	}
}

void create_unique_number()
{};

void create_file()
{
	printf("Beginning of create_file(): ");
	printf(attr_value[1].String());
	printf("\n");

	status = dir_where_called.CreateFile(new_file_name.String(), &new_file, true);
	if(status != B_OK)
	{
		new_file_name.Prepend("Can't create file \"");
		new_file_name.Append("\".");		
		error(new_file_name.String());
		return;
	}
	
	// adding the type
	// but first I need to get a BNode object for the file
	// so I can add the BEOS:TYPE attribute

	path_to_new_file = path_where_called.Path();
	path_to_new_file.Append("/");
	path_to_new_file.Append(new_file_name);

	printf("path to new file: ");
	printf(path_to_new_file.String());
	printf("\n");

	status = new_file_node.SetTo(path_to_new_file.String());
	if( status != B_OK )
		error_check("new_file_node.SetTo(path_to_new_file.String());\n", status);

	// write BEOS:TYPE attribute
	// is that enough?
	
	ssize_t		written_bytes = 0;

    written_bytes = new_file_node.WriteAttr("BEOS:TYPE", B_STRING_TYPE, 0,
									attr_value[2].String(), attr_value[2].Length()+1);

	if(written_bytes != attr_value[2].Length()+1)
	{ error("failure when adding type to new file:\nwritten_bytes != attr_value[number].Length()"); }

	error_check("write_attr() -- .WriteAttr() ", written_bytes);

	printf("attribute: ");
	printf(attr_name[2].String());
	printf("\n");

	printf("value: ");
	printf(attr_value[2].String());
	printf("\n");
	printf("written_bytes: %d", written_bytes);
	printf("\n");

	// write BEOS:PREF_APP attribute
	if (attr_value[7] == "1")
	{
		ssize_t		written_bytes = 0;

	    written_bytes = new_file_node.WriteAttr("BEOS:PREF_APP", B_STRING_TYPE, 0,
									attr_value[8].String(), attr_value[8].Length()+1);

		if(written_bytes != attr_value[8].Length()+1)
		{ error("failure when adding pref_app to new file:\nwritten_bytes != attr_value[number].Length()"); }

		error_check("write_attr() -- .WriteAttr() ", written_bytes);

		printf("attribute: ");
		printf(attr_name[8].String());
		printf("\n");

		printf("value: ");
		printf(attr_value[8].String());
		printf("\n");
		printf("written_bytes: %d", written_bytes);
		printf("\n");
	}
}

void error_check(const char * message, int32 status)
{
	printf(message);
		if (status == B_OK)					printf("B_OK \n");
		if (status == B_ERROR)				printf("B_ERROR \n");
		if (status == B_ENTRY_NOT_FOUND)	printf("B_ENTRY_NOT_FOUND \n");
		if (status == B_FILE_ERROR)			printf("B_FILE_ERROR \n");
		if (status == B_NOT_ALLOWED)		printf("B_NOT_ALLOWED \n");
		if (status == B_DEVICE_FULL)		printf("B_DEVICE_FULL \n");
		if (status == B_NO_MEMORY)			printf("B_NO_MEMORY \n");
		if (status == B_BAD_VALUE)			printf("B_BAD_VALUE \n");
		if (status == B_BUSY)				printf("B_BUSY \n");
		if (status == B_NO_INIT)			printf("B_NO_INIT \n");
		if (status == B_PERMISSION_DENIED)	printf("B_PERMISSION_DENIED \n");
		if (status == B_FILE_EXISTS)		printf("B_FILE_EXISTS \n");

}