//
// NewFile_window.cpp
//

//#include <ApplicationKit.h>
#include <SupportKit.h>
#include <StorageKit.h>
#include <InterfaceKit.h>
#include <Be.h>
#include <Application.h>
#include <stdio.h>
#include <TrackerAddOn.h>
#include <Node.h>
#include <String.h>
#include <Directory.h>
#include <FindDirectory.h>
#include <Path.h>
#include <File.h>
#include <malloc.h>
#include <cstring>
#include <Entry.h>

#include <stdio.h>

#include "NewFile_window.h"
#include "NewFile_view.h"


NewFile_window::NewFile_window(BRect WinSize, BNode app_node)
	: BWindow(WinSize, "NewFile setting",
	          B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	printf("Window constructor()\n");
	// setting up variables
	
	attr_name[0] = "Be Creative";
	attr_name[1] = "File Name";
	attr_name[2] = "File Type";
	attr_name[3] = "Ask About Name";
	attr_name[4] = "Add Extension";
	attr_name[5] = "Extension";
	attr_name[6] = "Open File";
	attr_name[7] = "Use My App";
	attr_name[8] = "My Preferred App";
	
	attr_value[0] = "1";
	attr_value[1] = "New";
	attr_value[2] = "text/plain";
	attr_value[3] = "0";
	attr_value[4] = "1";
	attr_value[5] = ".txt";
	attr_value[6] = "1";
	attr_value[7] = "0";
	attr_value[8] = "application/x-vnd.Be-STEE";

	my_app_node	=	app_node;

	for(int loop = 0; loop <= 8; loop++)	// read all attributes.
	{
		read_attr(loop);
	}
	
	// set up messages
	BMessage * about_msg = new BMessage ('abou');	
	BMessage * clone_msg = new BMessage ('clon');
	BMessage * save_msg = new BMessage('save');
	BMessage * reset_msg = new BMessage('rset');
	BMessage * add_ext_msg = new BMessage('aext');
	BMessage * open_file_msg = new BMessage('ofil');
	BMessage * use_my_app_msg = new BMessage('usmy');

	// set up widgets	
	BRect	ViewSize	(0,0,400,400);
	NewFile_view	*	my_view		=	new		NewFile_view(ViewSize);

	about_button_rect.Set		(5,160,55,190);
	clone_button_rect.Set		(130,160,180,190);
	reset_button_rect.Set		(190,160,240,190);
	save_button_rect.Set		(250,160,300,190);
	
	BButton * about_button = new BButton(about_button_rect, "about_button", "about", about_msg);
	BButton * clone_button = new BButton(clone_button_rect, "clone_button", "clone", clone_msg);	
	BButton * save_button = new BButton(save_button_rect, "save_button", "save", save_msg);
	BButton * reset_button = new BButton(reset_button_rect, "reset_button", "reset", reset_msg);

	BRect	file_name_r			(5,10,300,30);
	BRect	file_type_r			(5,30,300,50);
	BRect	add_ext_r			(5,50,300,70);
	BRect	ext_r				(5,70,300,90);
	BRect	open_file_r			(5,90,300,110);
	BRect	use_my_app_r		(5,110,300,130);
	BRect	my_preferred_app_r	(5,130,300,150);
	
    file_name = new BTextControl (file_name_r, "file_name", "Base name", attr_value[1].String(), NULL);
	file_type = new BTextControl (file_type_r, "file_type", "MIME type", attr_value[2].String(), NULL);
   	ext = new BTextControl (ext_r, "ext", "Extension", attr_value[5].String(), NULL);
	my_preferred_app = new BTextControl (my_preferred_app_r, "my_preferred_app", "App signature",
    						attr_value[8].String(), NULL);

	file_name->SetDivider(80);
	file_type->SetDivider(80);
	ext->SetDivider(80);
	my_preferred_app->SetDivider(80);

	add_ext	= new BCheckBox (add_ext_r, "add_ext", "Add extension", add_ext_msg);
	use_my_app = new BCheckBox (use_my_app_r, "use_my_app", "Using", use_my_app_msg);
	open_file = new BCheckBox (open_file_r, "open_file", "Open", open_file_msg);

	if(attr_value[4] == "1") add_ext->SetValue(B_CONTROL_ON);
	if(attr_value[7] == "1") use_my_app->SetValue(B_CONTROL_ON);
	if(attr_value[6] == "1") open_file->SetValue(B_CONTROL_ON);
	
	
	Lock();
	AddChild(my_view);
	my_view->AddChild(about_button);	
	my_view->AddChild(clone_button);
	my_view->AddChild(save_button);
	my_view->AddChild(reset_button);

	my_view->AddChild(file_name);
	my_view->AddChild(file_type);
	my_view->AddChild(add_ext);
	my_view->AddChild(ext);
	my_view->AddChild(open_file);
	my_view->AddChild(use_my_app);
	my_view->AddChild(my_preferred_app);
	Unlock();
}

NewFile_window::~NewFile_window() { }

void NewFile_window::MessageReceived(BMessage * message)
{
	switch(message->what)
	{
		case 'save':
			// git those values
			attr_value[1]	=	file_name->Text();
			attr_value[2]	=	file_type->Text();
			attr_value[5]	=	ext->Text();
			attr_value[8]	=	my_preferred_app->Text();
			
			for(int loop = 0; loop <= 8; loop++)	// write all attributes.
			{
				write_attr(loop);
			}

			be_app->PostMessage(B_QUIT_REQUESTED);	

			break;

		case 'rset':
			// back to default values
			file_name->SetText("New");
			file_type->SetText("text/plain");
			ext->SetText(".txt");
			my_preferred_app->SetText("application/x-vnd.Be-STEE");

			add_ext->SetValue(B_CONTROL_ON);
			attr_value[4] = "1";
			
			open_file->SetValue(B_CONTROL_ON);
			attr_value[6] = "1";
	
			use_my_app->SetValue(B_CONTROL_OFF);
			attr_value[7] = "0";
			break;
		case 'abou':
			  (new BAlert(0, "NewFile v003 Tracker add-on\n\n"
              "Compiled by Jonas Sundström.\n"
			  "Copyleft !" B_UTF8_COPYRIGHT " 1999 Mirilla Software.\n"
			  "Let me know if you want to use the code.\n\n"
              "Install-Me functionality by Raphael Moll.\n"
			  "Thanks to Be Inc. and the developer community, for tips & sample code.\n\n"
			  "It should be harmless, but you never know..\n\n"
			  "Feedback goes to:\n"
			  "s96j1su@csd.uu.se\n"
              "http://www.csd.uu.se/~s96j1su/",
              "Interesting.."))->Go(); 
			break;
		case 'clon':
			// Some code is needed here..
			// got to pop up a new window
			// asking for name and shortcut
			  (new BAlert(0, "NewFile Clone-No-Matic\n\n"
              "I intend to make this a little more automated.\n"
              "Until then, open your Tracker add-on folder..\n"
			  "/boot/home/config/add-ons/Tracker\n"
			  "..and duplicate NewFile manually.\n\n"
			  "Don't forget to give the copy a suitable\n"
			  "name and a shortcut key..\n(append '-N' for example)\n",
              "I'll try.."))->Go(); 			
			break;
		case 'aext':
			if (attr_value[4] == "1")
			{
				attr_value[4] = "0";
				printf("add_ext is OFF \n");
			}
			else if (attr_value[4] == "0")
			{
				attr_value[4] = "1";
				printf("add_ext is ON \n");
			}
			else
			{
				printf("add_ext not valid boolean value\n");
				attr_value[4] = "0";			
			}
			break;
		case 'ofil':
			if (attr_value[6] == "1")
			{
				attr_value[6] = "0";
				printf("open_file is OFF \n");
			}
			else if (attr_value[6] == "0")
			{
				attr_value[6] = "1";
				printf("open_file is ON \n");
			}
			else
			{
				printf("open_file not valid boolean value\n");
				attr_value[6] = "0";			
			}
			break;
		case 'usmy':
			if (attr_value[7] == "1")
			{
				attr_value[7] = "0";
				printf("use_my_app is OFF \n");
			}
			else if (attr_value[7] == "0")
			{
				attr_value[7] = "1";
				printf("use_my_app is ON \n");
			}
			else
			{
				printf("use_my_app not valid boolean value\n");
				attr_value[7] = "0";			
			}
			break;

		default:
			printf("Switch(default).\n");
			break;
	}
}


void
NewFile_window::read_attr(int number)
{
	ssize_t		read_bytes = 0;
	char	*	my_buffer  = (char *) malloc(B_FILE_NAME_LENGTH);
	attr_info	info;
	
	status = my_app_node.GetAttrInfo(attr_name[number].String(), &info);

		error_check("read_attr : my_app_node.GetAttrInfo", status);

	if (status == B_ENTRY_NOT_FOUND)
	{
		printf("Couldn't find attribute: ");
		printf(attr_name[number].String());
		printf("\n");
		return;
	}	
	else if (status != B_NO_ERROR)
	{
		printf("Darn.. Somethings wrong about my ");
		printf(attr_name[number].String());
		printf(" attribute.\n");
		return;
	}

	read_bytes = my_app_node.ReadAttr(attr_name[number].String(), B_STRING_TYPE, 0, my_buffer, 256);

	if (read_bytes > 0)
	{
		attr_value[number].Truncate(0);			// I had some problems to Assign the char * to the BStrin
		attr_value[number].Append(my_buffer, read_bytes);	// so this is a temporary solution
		printf("Appending buffer\n");						// Oh, the basics can be so annoying sometimes
	}
	// else use standard values
	
		error_check("read_attr() -- .ReadAttr()", read_bytes);

	printf("attribute : ");
	printf(attr_name[number].String());
	printf("\n");

	printf("value: ");
	printf(attr_value[number].String());
	printf("\n");
	printf("read_bytes: %d", read_bytes);
	printf("\n");

	printf("buffer length: %d", strlen(my_buffer));
	printf("\n");

	free(my_buffer); my_buffer = NULL;	
}

void
NewFile_window::error_check(const char * message, int32 status)
{
	printf(message);

	if (status == B_OK)					printf("B_OK \n");
	if (status == B_ERROR)				printf("B_ERROR \n");
	if (status == B_ENTRY_NOT_FOUND)	printf("B_ENTRY_NOT_FOUND \n");
	if (status == B_FILE_ERROR)			printf("B_FILE_ERROR \n");
	if (status == B_NOT_ALLOWED)		printf("B_NOT_ALLOWED \n");
	if (status == B_DEVICE_FULL)		printf("B_DEVICE_FULL \n");
	if (status == B_NO_MEMORY)			printf("B_NO_MEMORY \n");
	if (status == B_BAD_VALUE)			printf("B_BAD_VALUE \n");
	if (status == B_BUSY)				printf("B_BUSY \n");
	if (status == B_NO_INIT)			printf("B_NO_INIT \n");
	if (status == B_PERMISSION_DENIED)	printf("B_PERMISSION_DENIED \n");
	if (status == B_FILE_EXISTS)		printf("B_FILE_EXISTS \n");
}

void
NewFile_window::write_attr(int number)
{
	ssize_t		written_bytes = 0;

    written_bytes = my_app_node.WriteAttr(attr_name[number].String(), B_STRING_TYPE, 0,
									attr_value[number].String(), attr_value[number].Length());

	if(written_bytes != attr_value[number].Length())
	{ printf("failure: written_bytes != attr_value[number].Length()"); }

	error_check("write_attr() -- .WriteAttr() ", written_bytes);

	printf("attribute: ");
	printf(attr_name[number].String());
	printf("\n");

	printf("value: ");
	printf(attr_value[number].String());
	printf("\n");
	printf("written_bytes: %d", written_bytes);
	printf("\n");
}

void
NewFile_window::Quit()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	BWindow::Quit();
}

